#knapsack.mod

#Master Problem
param Nitem;
param Ncut;
param weight{i in 1..Nitem};
param value{i in 1..Nitem};
param capacity;
param acut {i in 1..Ncut, j in 1..Nitem};
param bcut {i in 1..Ncut};

var x{i in 1..Nitem} binary;

maximize Profit: sum{i in 1..Nitem}value[i]*x[i];

subject to Capacity_Constraint:  sum{i in 1..Nitem}weight[i]*x[i] <= capacity;
subject to Upper_Lower_Bound {i in 1..Nitem}:  0 <= x[i] <=1;
subject to Valid {i in 1..Ncut}: sum{j in 1..Nitem} acut[i,j]*x[j] <=bcut[i];

#Cut Generation
param xx{i in 1..Nitem};
var y{i in 1..Nitem} binary;

maximize Violation: sum{i in 1..Nitem}(xx[i]-1)*y[i];

subject to Cover: sum{i in 1..Nitem}weight[i]*y[i] >=capacity+0.001;